﻿using AngleSharp.Html.Dom;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;

namespace DeskTopMascot
{
    /// <summary>
    /// CoronaWindow.xaml の相互作用ロジック
    /// </summary>
    public partial class CoronaWindow : Window
    {
        public CoronaWindow()
        {
            InitializeComponent();
        }

        public void SetTopLeft(double top, double left)
        {
            Dispatcher.Invoke(() => this.Top = top);
            Dispatcher.Invoke(() => this.Left = left);
        }

        public void DisplayTitle(IHtmlDocument doc)
        {
            var todayicon = doc.QuerySelectorAll("section[class=today-weather] div[class=weather-icon]").ToList();
            var today = doc.QuerySelectorAll("section[class=today-weather] dl[class=date-value]").ToList();
            var tomorrowicon = doc.QuerySelectorAll("section[class=tomorrow-weather] div[class=weather-icon]").ToList();
            var tomorrow = doc.QuerySelectorAll("section[class=tomorrow-weather] dl[class=date-value]").ToList();
            Dispatcher.Invoke(() => 
            {
                today_img.Source = new BitmapImage(new Uri(todayicon[0].Children[0].GetAttribute("src"), UriKind.Absolute));
                today_txt.Content = todayicon[0].Children[1].TextContent;
                today_highest_txt.Content = string.Join(" ", today[0].Children.Take(3).Select(n => n.TextContent));
                today_lowest_txt.Content = string.Join(" ", today[0].Children.Skip(3).Take(3).Select(n => n.TextContent));

                tomorrow_img.Source = new BitmapImage(new Uri(tomorrowicon[0].Children[0].GetAttribute("src"), UriKind.Absolute));
                tomorrow_txt.Content = tomorrowicon[0].Children[1].TextContent;
                tomorrow_highest_txt.Content = string.Join(" ", tomorrow[0].Children.Take(3).Select(n => n.TextContent));
                tomorrow_lowest_txt.Content = string.Join(" ", tomorrow[0].Children.Skip(3).Take(3).Select(n => n.TextContent));
            });
        }

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if ((sender as CoronaWindow).IsActive)
            {
                e.Cancel = true;
                this.Visibility = Visibility.Hidden;
            }
        }
    }
}
